﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;

// For more information on enabling Web API for empty projects, visit http://go.microsoft.com/fwlink/?LinkID=397860

namespace APIHelloWorld.Controllers
{
    //[!] 어트리뷰트 라우팅
    [Route("api/[controller]")]
    //[Route("api/sub/[controller]")]
    //[Route("api/Hello")]
    public class APIHelloworldWithValueController : Controller
    {
        // GET: api/APIHelloworld
        [HttpGet]
        public IEnumerable<Value> Get()
        {
            //return new string[] { "안녕하세요.", "반갑습니다." };
            return new Value[] {
                new Value { Id = 1, Text = "안녕하세요" },
                new Value { Id = 1, Text = "반갑습니다." } };
        }

        //[!] 라우트 매개변수
        // GET api/api/APIHelloworld/id
        //[!] 모델 바인딩 + 인라인 제약 조건(:)
        //[HttpGet("{id}")]
        [HttpGet("{id:int}")]
        public Value Get(int id)
        {
            //return "value";
            //return $"넘어온값 : {id}";
            return new Value { Id = id, Text = $"넘어온값 : {id}" };
        }

        ////[2]
        //[HttpPost]
        //[Produces("application/json", Type = typeof(Value))]
        //[Consumes("application/json")]
        //public IActionResult Post([FromBody]Value value)
        //{
        //    //chrome://apps 크롬앱 POSTMAN, Swagger (Swashbuckle), Fildder 등의 외부 도구로 테스트

        //    // 넘어온 JSON 데이터를 DB에 저장 후 Id 값 반환
        //    //var a = value;

        //    return CreatedAtAction("Get", new { IDictionary = value.Id }, value);
        //}


        //[3]
        [HttpPost]
        [Produces("application/json", Type = typeof(Value))]
        [Consumes("application/json")]
        public IActionResult Post([FromBody]Value value)
        {
            if (!ModelState.IsValid)
            {
                return BadRequest(ModelState); //400에러
            }

            return CreatedAtAction("Get", new { IDictionary = value.Id }, value);
        }

    }


    // JSON, XML : 기본포멧터 JSON
    public class Value
    {
        public int Id { get; set; }
        [Required(ErrorMessage ="Text 속성은 필수 입력값입니다.")]
        public string Text { get; set; }
    }
}